"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _Node = _interopRequireDefault(require("./Node"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

class Inline extends _Node.default {
  /**
   * Render the node
   * @param {function(name: string): (React.ComponentClass|React.ReactNode)} getter
   * @param {React.Key} [key]
   * @return {React.ReactNode}
   */
  render(getter, key) {
    const {
      name
    } = this;
    const value = getter(name);

    if (!value) {
      return null;
    }

    if (typeof value === 'function') {
      const Component = value;
      return /*#__PURE__*/_react.default.createElement(Component, {
        key: key,
        name: name
      });
    }

    if (undefined !== key && typeof value === 'object') {
      return /*#__PURE__*/_react.default.createElement(_react.Fragment, {
        key: key
      }, value);
    }

    return value;
  }

}

exports.default = Inline;